////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   : EVE Online KillMail Sender
//  * Unit Name : kmsAboutDlg
//  * Purpose   :   " " :)
//  * Author    :  (Rouse_) 
//  * Copyright :  Fangorn Wizards Lab 1998 - 2009 ()
//  * Version   : 1.09
//  * Home Page : http://rouse.drkb.ru/kms/
//  ****************************************************************************
//

unit kmsAboutDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TkmsAboutDialog = class(TForm)
    lblDsc: TLabel;
    Image1: TImage;
    lblAuthor: TLabel;
    gbTemplates: TGroupBox;
    gbLang: TGroupBox;
    Button: TButton;
    lvTemplates: TListView;
    lvLanguages: TListView;
    lblURL: TLabel;
    lblVersion: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lblURLMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lblURLMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lblURLClick(Sender: TObject);
  end;

var
  kmsAboutDialog: TkmsAboutDialog;

implementation

uses
  IniFiles,
  ShellAPI;

{$R *.dfm}

function GetVersion: String;
var
  VerInfoSize: DWORD;
  VerInfo: Pointer;
  VerValueSize: DWORD;
  VerValue: PVSFixedFileInfo;
  Dummy: DWORD;
begin
  VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
  GetMem(VerInfo, VerInfoSize);
  try
    GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
    VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
    with VerValue^ do
    begin
      Result := IntToStr(dwFileVersionMS shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionMS and $FFFF);
      Result := Result + '.' + IntToStr(dwFileVersionLS shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionLS and $FFFF);
    end;
  finally
    FreeMem(VerInfo, VerInfoSize);
  end;
end;

procedure TkmsAboutDialog.FormActivate(Sender: TObject);
var
  SR: TSearchRec;
  Path: String;
  IniFile: TIniFile;
begin
  lblVersion.Caption := Format(
    'Version: %s', [GetVersion]);
  lvTemplates.Clear;
  Path := ExtractFilePath(ParamStr(0)) + 'Templates\';
  if FindFirst(Path + '*.tpl', faAnyFile, SR) = 0 then
  try
    repeat
      with lvTemplates.Items.Add do
      begin
        IniFile := TIniFile.Create(Path + SR.Name);
        try
          Caption := IniFile.ReadString('main', 'description', '');
          SubItems.Add(IniFile.ReadString('copyright', 'version', ''));
          SubItems.Add(IniFile.ReadString('copyright', 'author', ''));
        finally
          IniFile.Free;
        end;
      end;
    until FindNext(SR) <> 0;
  finally
    FindClose(SR);
  end;
  lvLanguages.Clear;
  Path := ExtractFilePath(ParamStr(0)) + 'Language\';
  if FindFirst(Path + '*.ini', faAnyFile, SR) = 0 then
  try
    repeat
      with lvLanguages.Items.Add do
      begin
        IniFile := TIniFile.Create(Path + SR.Name);
        try
          Caption := IniFile.ReadString('main', 'description', '');
          SubItems.Add(IniFile.ReadString('copyright', 'version', ''));
          SubItems.Add(IniFile.ReadString('copyright', 'author', ''));
        finally
          IniFile.Free;
        end;
      end;
    until FindNext(SR) <> 0;
  finally
    FindClose(SR);
  end;
end;

procedure TkmsAboutDialog.FormCreate(Sender: TObject);
begin
  Screen.Cursors[crHandPoint] := LoadCursor(0, IDC_HAND);
end;

procedure TkmsAboutDialog.lblURLClick(Sender: TObject);
begin
  ShellExecute(Handle, nil, 'http://rouse.drkb.ru/kms/', nil, nil, SW_SHOWNORMAL);
end;

procedure TkmsAboutDialog.lblURLMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  lblURL.Font.Color := clRed;
end;

procedure TkmsAboutDialog.lblURLMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  lblURL.Font.Color := clBlue;      
end;

end.
